//
// 菑VF[_[@0.02
// T.Ogura
// 27.Nov 2010 
// 28.Nov 2010 nʂւ̉eǉ
//

#define Hatching_Pattern_Image "hatching4.jpg"			// nb`Op^[
#define EDGE_PARAM 0.003					// GbW̑
#define SHADOWPOWER 0.3						// ZtVh[̋

#define HATCIHNG_TILE_REPEAT	3				// nb`Oׂ̍
#define HATCIHNG_MAX_INDEX	15				// 邳̏ iƔZA16ɂƔoj
#define HATCHING_INDEX_RANGE	17				// 邳̒iK (傫Ɩ邭Ȃj
#define HATCHING_DIR		float2(-1,1)			// nb`O̕
#define HATCHING_OPERATOR       =  	// *=  = w	// Cg̗L/

#define HATCHING_SHADOW_PARAM float2(60,60) // nʂɗẽnb`Op^[ׂ̍
#define HATCHING_SHADOW_COLOR 0.6           // nʂɗe̐F

float ftime : TIME <bool SyncInEditMode=false;>;
//-------------------------------------------------------------------------------
float4x4 WorldViewProjMatrix      : WORLDVIEWPROJECTION;
float4x4 WorldMatrix              : WORLD;
float4x4 ViewMatrix               : VIEW;
float4x4 LightWorldViewProjMatrix : WORLDVIEWPROJECTION < string Object = "Light"; >;

float3   LightDirection    : DIRECTION < string Object = "Light"; >;
float3   CameraPosition    : POSITION  < string Object = "Camera"; >;

// }eAF
float4   MaterialDiffuse   : DIFFUSE  < string Object = "Geometry"; >;
float3   MaterialAmbient   : AMBIENT  < string Object = "Geometry"; >;
float3   MaterialEmmisive  : EMISSIVE < string Object = "Geometry"; >;
float3   MaterialSpecular  : SPECULAR < string Object = "Geometry"; >;
float    SpecularPower     : SPECULARPOWER < string Object = "Geometry"; >;
float3   MaterialToon      : TOONCOLOR;
// CgF
float3   LightDiffuse      : DIFFUSE   < string Object = "Light"; >;
float3   LightAmbient      : AMBIENT   < string Object = "Light"; >;
float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;

static float4 DiffuseColor  = MaterialDiffuse  * float4(LightDiffuse, 1.0f);
static float3 AmbientColor  = saturate(MaterialAmbient  * LightAmbient + MaterialEmmisive);
static float3 SpecularColor = MaterialSpecular * LightSpecular;
bool     parthf;   // p[XyNeButO
bool     transp;   // tO
bool	 spadd;    // XtBA}bvZtO
#define SKII1    1500
#define SKII2    8000
#define Toon     3
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state {
    texture = <ObjectTexture>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
};
texture ObjectSphereMap: MATERIALSPHEREMAP;
sampler ObjSphareSampler = sampler_state {
    texture = <ObjectSphereMap>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
};
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);
//-------------------------------------------------------------------------------
// nb`OeNX`
//-------------------------------------------------------------------------------
texture2D HatchingTex
<
   string ResourceName = Hatching_Pattern_Image;
>;
sampler HatchingMap = sampler_state
{
   Texture = (HatchingTex);
//   ADDRESSU = WRAP;
//   ADDRESSV = WRAP;
//   ADDRESSW = WRAP;
   MAGFILTER = LINEAR;
   MINFILTER = LINEAR;
//   MIPFILTER = NONE;
};
//-------------------------------------------------------------------------------
//@WGbW
//-------------------------------------------------------------------------------
technique EdgeTec < string MMDPass = "edge"; 
	string Script = ""; 
> {}

//-------------------------------------------------------------------------------
// nb`O֐
//-------------------------------------------------------------------------------

float hatching(float4 c,float2 tex)
{
	float f;
	float f1 = 0;
	float f2 = 0;
	float l = c.x * 0.3 + c.y * 0.6 + c.z * 0.1;
	l *= HATCHING_INDEX_RANGE;
	
	float weight = frac(l);

	int index = min(HATCIHNG_MAX_INDEX,l);
	if (index > 15){ 
		f1 = 1.0;
	}else{
		int a = 3-index % 4;
		int b = index / 4;
		f1 = (tex2D( HatchingMap, frac((tex.yx)*HATCHING_DIR*HATCIHNG_TILE_REPEAT)/4.0+float2(0.25 * a,0.25 * b) )).x ;
	}
	
	index = min(HATCIHNG_MAX_INDEX,l+1.0);
	if (index > 15){ 
		f2 = 1.0;
	}else{
		int a = 3-index % 4;
		int b = index / 4;
		f2 = (tex2D( HatchingMap, frac((tex.yx)*HATCHING_DIR*HATCIHNG_TILE_REPEAT)/4.0+float2(0.25 * a,0.25 * b) )).x ;
	}
	
	f = f2 * weight + f1 * (1.0 - weight);
	
	return f;
}

struct VS_OUTPUT {
    float4 Pos      : POSITION;     // ˉeϊW
    float4 ZCalcTex : TEXCOORD0;    // Zl
    float2 Tex      : TEXCOORD1;    // eNX`
    float3 Normal   : TEXCOORD2;    // @
    float3 Eye      : TEXCOORD3;    // JƂ̑Έʒu
    float2 SpTex    : TEXCOORD4;	// XtBA}bveNX`W
    float4 Color    : COLOR0;       // fBt[YF
};

///////////////////////////////////////////////////////////////////////////////////////////////
// eiZtVhEj`
struct VS_S_OUTPUT {
    float4 Pos      : POSITION;     // ˉeϊW
    float4 PPos     : TEXCOORD0;    // epW
};
VS_S_OUTPUT Shadow_VS(float4 Pos : POSITION)
{
	VS_S_OUTPUT Out = (VS_S_OUTPUT)0;
	Out.Pos = mul( Pos, WorldViewProjMatrix );
	Out.PPos = mul( Pos, WorldMatrix );
    return Out;
}
float4 Shadow_PS(VS_S_OUTPUT IN) : COLOR
{
	float2 p = IN.PPos.xz / IN.PPos.w / HATCHING_SHADOW_PARAM;
	float f = hatching (HATCHING_SHADOW_COLOR,p);
	return float4(AmbientColor.rgb,1.0-f);
}
technique ShadowTec < string MMDPass = "shadow"; > {
    pass DrawShadow {
        VertexShader = compile vs_2_0 Shadow_VS();
        PixelShader  = compile ps_2_0 Shadow_PS();
    }
}

//----------------------------------
// GbWPASS
//----------------------------------

VS_OUTPUT Edge_VS(float4 Pos : POSITION, float3 Normal : NORMAL, float2 Tex : TEXCOORD0, uniform bool useTexture, uniform bool useSphereMap, uniform bool useToon)
{
    VS_OUTPUT Out = (VS_OUTPUT)0;

    float4 p  = mul( Pos, ViewMatrix );
    float x = p.z / p.w;						// J̋
    float4 w = float4(Normal,0)*x*EDGE_PARAM;	// @֖c܂
    
	Out.Pos = mul( Pos+w, WorldViewProjMatrix );
    Out.Color.rgb = AmbientColor;				// GbW̐F
    Out.Tex = Tex;   
	Out.Normal = normalize( mul( Normal, (float3x3)WorldMatrix ) );
    return Out;
}

float4 Edge_PS(VS_OUTPUT IN, uniform bool useTexture, uniform bool useSphereMap, uniform bool useToon) : COLOR
{
    float4 Color = IN.Color;
    if ( useTexture ) {
        // eNX`Kp
        float4 TexColor = tex2D( ObjTexSampler, IN.Tex );
        Color *= TexColor;
    }
	Color.rgb = Color.rgb / 2.0 + 0.5; // ƔۂĂ݂
    Color.w = 1;
    return Color; 
}

//-------------------------------------------------------------------------------
// IuWFNg` _VF[_[
//-------------------------------------------------------------------------------

// _VF[_
VS_OUTPUT Hatching_VS(float4 Pos : POSITION, float3 Normal : NORMAL, float2 Tex : TEXCOORD0, uniform bool useTexture, uniform bool useSphereMap, uniform bool useToon)
{
    VS_OUTPUT Out = (VS_OUTPUT)0;

    // J_̃[hr[ˉeϊ
    float4 p = Pos;
    Out.Pos = mul( p, WorldViewProjMatrix );
    // JƂ̑Έʒu
    Out.Eye = CameraPosition - mul( p, WorldMatrix );
    // _@
    Out.Normal = normalize( mul( Normal, (float3x3)WorldMatrix ) );
	// Cg_ɂ郏[hr[ˉeϊ
    Out.ZCalcTex = mul( Pos, LightWorldViewProjMatrix );  
    // fBt[YF{ArGgF vZ
    Out.Color.rgb = AmbientColor;
    if ( !useToon ) {
        Out.Color.rgb += max(0,dot( Out.Normal, -LightDirection )) * DiffuseColor.rgb;
    }
    Out.Color.a = DiffuseColor.a;
    Out.Color = saturate( Out.Color );  
    // eNX`W
    Out.Tex = Tex;  
    if ( useSphereMap ) {
        // XtBA}bveNX`W
        float2 NormalWV = mul( Out.Normal, (float3x3)ViewMatrix );
        Out.SpTex.x = NormalWV.x * 0.5f + 0.5f;
        Out.SpTex.y = NormalWV.y * -0.5f + 0.5f;
    }
    
    return Out;
}

//-------------------------------------------------------------------------------
// IuWFNg`iZtVhEOFFj
//-------------------------------------------------------------------------------

float4 Hatching_Basic_PS(VS_OUTPUT IN, uniform bool useTexture, uniform bool useSphereMap, uniform bool useToon) : COLOR0
{
	float4 T = 0;
    // XyLFvZ
    float3 HalfVector = normalize( normalize(IN.Eye) + -LightDirection );
    float3 Specular = pow( max(0,dot( HalfVector, normalize(IN.Normal) )), SpecularPower ) * SpecularColor;
    
    float4 Color = IN.Color;
    if ( useTexture ) {
        // eNX`Kp
        T = tex2D( ObjTexSampler, IN.Tex );
        Color *= tex2D( ObjTexSampler, IN.Tex );
    }
    if ( useSphereMap ) {
        // XtBA}bvKp
        float4 TexColor = tex2D(ObjSphareSampler,IN.SpTex);

        if(spadd){
			Color += TexColor;
			T += TexColor;
		}
        else{
              Color *= TexColor;
              T *= TexColor;
        }
    }
     // XyLKp
    Color.rgb += Specular;
   
    Color.rgb HATCHING_OPERATOR max(0,(dot( IN.Normal, -LightDirection )+1.0 ) / 2.0);
	float f = hatching (Color,IN.Tex);
	Color.xyz = (1.0-f) * T.xyz + float3(f,f,f);

    return Color;
}


//-------------------------------------------------------------------------------
// IuWFNg`iZtVhEONj
//-------------------------------------------------------------------------------
sampler DefSampler : register(s0);

// sNZVF[_
float4 Hatching_Shadow_PS(VS_OUTPUT IN, uniform bool useTexture, uniform bool useSphereMap, uniform bool useToon) : COLOR
{
	float4 T=0;
    // XyLFvZ
    float3 HalfVector = normalize( normalize(IN.Eye) + -LightDirection );
    float3 Specular = pow( max(0,dot( HalfVector, normalize(IN.Normal) )), SpecularPower ) * SpecularColor;
    
    float4 Color = IN.Color;
//    float4 ShadowColor = float4(AmbientColor, Color.a);  // e̐F
    if ( useTexture ) {
        // eNX`Kp
        T = tex2D( ObjTexSampler, IN.Tex );
        Color *= T;
//        ShadowColor *= T;
    }
    if ( useSphereMap ) {
        // XtBA}bvKp
        float4 TexColor = tex2D(ObjSphareSampler,IN.SpTex);
        if(spadd) {
            Color += TexColor;
            T += TexColor;
//            ShadowColor += TexColor;
        } else {
            Color *= TexColor;
            T *= TexColor;
//            ShadowColor *= TexColor;
        }
    }
    // XyLKp
    Color.rgb += Specular;
     // eNX`Wɕϊ
    IN.ZCalcTex /= IN.ZCalcTex.w;
    float2 TransTexCoord;
    TransTexCoord.x = (1.0f + IN.ZCalcTex.x)*0.5f;
    TransTexCoord.y = (1.0f - IN.ZCalcTex.y)*0.5f;
    
    float4 r = Color;
    float comp;

   if( any( saturate(TransTexCoord) != TransTexCoord ) ) {
		;
    } else {
        if(parthf) {
            // ZtVhE mode2
            comp=1-saturate(max(IN.ZCalcTex.z-tex2D(DefSampler,TransTexCoord).r , 0.0f)*SKII2*TransTexCoord.y-0.3f);
        } else {
            // ZtVhE mode1
            comp=1-saturate(max(IN.ZCalcTex.z-tex2D(DefSampler,TransTexCoord).r , 0.0f)*SKII1-0.3f);
        }
        comp = max(0,(dot( IN.Normal, -LightDirection )+1.0 ) / 2.0) * (comp*SHADOWPOWER+(1.0-SHADOWPOWER));
 //       ShadowColor.rgb *= MaterialToon;

 //       float4 ans = lerp(ShadowColor, Color, comp);
 //       if( transp ) ans.a = 0.5f;
 //       r = ans;
    }
	Color HATCHING_OPERATOR comp;
	
	float f = hatching (Color,IN.Tex);
	Color.xyz = (1.0-f) * T.xyz + float3(f,f,f);
	Color.a  = 1.0;
	return Color;	

}
//-------------------------------------------------------------------------------------------------------------

technique HatchingTec1 < string MMDPass = "object"; bool UseTexture = true; bool UseSphereMap = false; bool UseToon = false;
    string Script = 
                    "pass=DrawObject;"
                    ;
> {
    pass DrawObject {
       VertexShader = compile vs_3_0 Hatching_VS(true, false, false);
       PixelShader  = compile ps_3_0 Hatching_Basic_PS(true, false, false);
    }
}
technique HatchingTec2 < string MMDPass = "object"; bool UseTexture = true; bool UseSphereMap = false; bool UseToon = true;
    string Script = 
                    "pass=DrawObject;"
					"pass=DrawEdge;"
                    ;
> {
    pass DrawEdge {
        AlphaBlendEnable = TRUE;
		CULLMODE = CW;        
        VertexShader = compile vs_3_0 Edge_VS(true, false, true);
        PixelShader  = compile ps_3_0 Edge_PS(true, false, true);
    }
    pass DrawObject {
       VertexShader = compile vs_3_0 Hatching_VS(true, false, true);
       PixelShader  = compile ps_3_0 Hatching_Basic_PS(true, false, true);
    }
}

technique HatchingTec3 < string MMDPass = "object"; bool UseTexture = true; bool UseSphereMap = true; bool UseToon = false;
    string Script = 
                    "pass=DrawObject;"
                    ;
> {
    pass DrawObject {
       VertexShader = compile vs_3_0 Hatching_VS(true, true, false);
       PixelShader  = compile ps_3_0 Hatching_Basic_PS(true, true, false);
    }
}
technique HatchingTec4 < string MMDPass = "object"; bool UseTexture = true; bool UseSphereMap = true; bool UseToon = true;
    string Script = 
                    "pass=DrawObject;"
					"pass=DrawEdge;"
                    ;
> {
    pass DrawEdge {
        AlphaBlendEnable = TRUE;
		CULLMODE = CW;        
        VertexShader = compile vs_3_0 Edge_VS(true, true, true);
        PixelShader  = compile ps_3_0 Edge_PS(true, true, true);
    }
    pass DrawObject {
       VertexShader = compile vs_3_0 Hatching_VS(true, true, true);
       PixelShader  = compile ps_3_0 Hatching_Basic_PS(true, true, true);
    }
}
//-------------------------------------------------------------------------------------------------------------
technique MainTecBS1  <
	string MMDPass = "object_ss"; bool UseTexture = true; bool UseSphereMap = false; bool UseToon = false;
    string Script = 
                    "pass=DrawObject;"
                    ;
    >{
    pass DrawObject {
		CULLMODE = NONE;        
        VertexShader = compile vs_3_0 Hatching_VS(true, false, false);
        PixelShader  = compile ps_3_0 Hatching_Shadow_PS(true, false, false);
    }
}
technique MainTecBS2  <
	string MMDPass = "object_ss"; bool UseTexture = true; bool UseSphereMap = false; bool UseToon = true;
    string Script = 
                    "pass=DrawObject;"
					"pass=DrawEdge;"
                    ;
    >{
    pass DrawEdge {
        AlphaBlendEnable = TRUE;
		CULLMODE = CW;        
        VertexShader = compile vs_3_0 Edge_VS(true, false, true);
        PixelShader  = compile ps_3_0 Edge_PS(true, false, true);
    }
    pass DrawObject {
		CULLMODE = NONE;        
        VertexShader = compile vs_3_0 Hatching_VS(true, false, true);
        PixelShader  = compile ps_3_0 Hatching_Shadow_PS(true, false, true);
    }
}
technique MainTecBS3  <
	string MMDPass = "object_ss"; bool UseTexture = true; bool UseSphereMap = true; bool UseToon = false;
    string Script = 
                    "pass=DrawObject;"
                    ;
    >{
    pass DrawObject {
		CULLMODE = NONE;        
        VertexShader = compile vs_3_0 Hatching_VS(true, true, false);
        PixelShader  = compile ps_3_0 Hatching_Shadow_PS(true, true, false);
    }
}
technique MainTecBS4  <
	string MMDPass = "object_ss"; bool UseTexture = true; bool UseSphereMap = true; bool UseToon = true;
    string Script = 
                    "pass=DrawObject;"
					"pass=DrawEdge;"
                    ;
    >{
    pass DrawEdge {
        AlphaBlendEnable = TRUE;
		CULLMODE = CW;        
        VertexShader = compile vs_3_0 Edge_VS(true, true, true);
        PixelShader  = compile ps_3_0 Edge_PS(true, true, true);
    }
    pass DrawObject {
		CULLMODE = NONE;        
        VertexShader = compile vs_3_0 Hatching_VS(true, true, true);
        PixelShader  = compile ps_3_0 Hatching_Shadow_PS(true, true, true);
    }
}
